
!XMLDoctypeDeclaration methodsFor: '*XML-Explorer' stamp: 'monty 3/10/2017 13:11'!
writeExplorerLabelXMLOn: aWriter
	aWriter doctype
		root: self root;
		publicID: self publicID;
		systemID: self systemID;
		write! !

!XMLDocument methodsFor: '*XML-Explorer' stamp: 'monty 3/10/2017 13:22'!
addExplorerContentsTo: aSequenceableCollection
	self hasDoctypeDeclaration
		ifTrue: [
			aSequenceableCollection addLast:
				(ObjectExplorerWrapper
					with: self doctypeDeclaration
					name: (self doctypeDeclaration explorerLabel contractTo: 32)
					model: self)].
	super addExplorerContentsTo: aSequenceableCollection.! !

!XMLDocument methodsFor: '*XML-Explorer' stamp: 'monty 3/10/2017 13:02'!
hasExplorerContents
	^ self hasDoctypeDeclaration
		or: [super hasExplorerContents]! !

!XMLDocument methodsFor: '*XML-Explorer' stamp: 'monty 3/10/2017 13:12'!
writeExplorerLabelXMLOn: aWriter
	self writeXMLDeclarationOn: aWriter! !

!XMLNodeWithChildren methodsFor: '*XML-Explorer' stamp: 'monty 3/10/2017 13:21'!
addExplorerContentsTo: aSequenceableCollection
	self nodesDo: [:each |
		aSequenceableCollection addLast:
			(ObjectExplorerWrapper
				with: each
				name: (each explorerLabel contractTo: 32)
				model: self)].! !

!XMLNodeWithChildren methodsFor: '*XML-Explorer' stamp: 'monty 3/10/2017 13:32'!
explorerContents
	self hasExplorerContents
		ifTrue: [| contents |
			contents := OrderedCollection new: self nodes size.
			self addExplorerContentsTo: contents.
			^ contents]
		ifFalse: [^ #()].! !

!XMLNodeWithChildren methodsFor: '*XML-Explorer' stamp: 'monty 3/10/2017 13:00'!
hasExplorerContents
	^ self hasChildren! !

!XMLNodeWithElements methodsFor: '*XML-Explorer' stamp: 'monty 3/10/2017 13:15'!
addExplorerContentsTo: aSequenceableCollection
	self nodesDo: [:each |
		(each isStringNode
			and: [each isEmpty
				or: [each isWhitespace]])
			ifFalse: [
				aSequenceableCollection addLast:
					(ObjectExplorerWrapper
						with: each
						name: (each explorerLabel contractTo: 32)
						model: self)]].! !

!XMLNodeWithElements methodsFor: '*XML-Explorer' stamp: 'monty 3/10/2017 13:28'!
hasExplorerContents
	^ self hasChildren
		and: [
			self nodes anySatisfy: [:each |
				each isStringNode not
					or: [each isEmpty not
						or: [each isWhitespace not]]]]! !

!XMLNode methodsFor: '*XML-Explorer' stamp: 'monty 3/21/2017 16:32'!
explorerContents
	^ #()! !

!XMLNode methodsFor: '*XML-Explorer' stamp: 'monty 3/10/2017 13:12'!
explorerLabel
	^ XMLWriter writeWith: [:writer |
		self writeExplorerLabelXMLOn: writer]! !

!XMLNode methodsFor: '*XML-Explorer' stamp: 'monty 3/10/2017 13:00'!
hasExplorerContents
	^ false! !

!XMLNode methodsFor: '*XML-Explorer' stamp: 'monty 3/10/2017 13:12'!
writeExplorerLabelXMLOn: aWriter
	self writeXMLOn: aWriter! !

!XMLElement methodsFor: '*XML-Explorer' stamp: 'monty 3/10/2017 13:31'!
writeExplorerLabelXMLOn: aWriter
	(self hasExplorerContents
		ifTrue: [aWriter startTag]
		ifFalse: [aWriter tag])
			name: self name;
			"uses setAttributes: for performance"
			setAttributes: attributes! !
